/***************************************************************************
                          dcfiletransferinfo.cpp  -  description
                             -------------------
    begin                : Sam Jul 13 2002
    copyright            : (C) 2002 by Mathias Kster
    email                : mathen@ketelhot.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qlabel.h>
#include <qpixmap.h>
#include <qpainter.h>
#include <qlineedit.h>

#include <dclib/cdownloadqueue.h>

#include "dcfiletransferinfo.h"
#include <dclib/dcos.h>

DCFileTransferInfo::DCFileTransferInfo()
{
}

DCFileTransferInfo::~DCFileTransferInfo()
{
}

/** */
void DCFileTransferInfo::Init( DCFileChunkObject * pFileChunk )
{
	int x1,x2;
	DCChunkObject * ChunkObject;

	LineEdit_FILENAME->setText( pFileChunk->m_sLocalFile.Data() );
	LineEdit_FILESIZE->setText( CString().setNum(pFileChunk->m_nSize).Data() );
	LineEdit_FILESIZEDONE->setText( CString().setNum(pFileChunk->m_nSizeDone).Data() );

	QPainter pa;
	QPixmap p(200,100);
	p.fill(Qt::white);

	pa.begin(&p);

	ChunkObject = 0;
	while( (ChunkObject=pFileChunk->m_Chunks.Next(ChunkObject)) != 0 )
	{
		if ( ChunkObject->m_bLocked == FALSE )
			pa.setPen( Qt::red );
		else
			pa.setPen( Qt::green );

		x1 = (ChunkObject->m_nStart*20000/pFileChunk->m_nSize);
        	x2 = (ChunkObject->m_nEnd*20000/pFileChunk->m_nSize);

		int ys,xs,ye,xe,y;

		xs = x1%200;
		ys = (x1-xs)/200;
		xe = x2%200;
		ye = (x2-xe)/200;

//		printf("%d %d %d %d\n",xs,xe,ys,ye);

		for(y=ys;y<=ye;y++)
		{
			if( (y==ys) && (y==ye) )
				pa.drawLine( xs, y, xe, y );
			else if ( y==ys )
				pa.drawLine( xs, y, 200, y );
			else if ( y==ye )
				pa.drawLine( 0, y, xe, y );
			else
				pa.drawLine( 0, y, 200, y );
		}
	}

	pa.end();

	PixmapLabel_CHUNKINFO->setPixmap(p);
}
