/***************************************************************************
                          dcmenuhandler.cpp  -  description
                             -------------------
    begin                : Don Mai 16 2002
    copyright            : (C) 2002 by Mathias Kster
    email                : mathen@ketelhot.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qpopupmenu.h>

#include "dcmenuhandler.h"

#include "res/connect_creating.xpm"
#include "res/connect_no.xpm"
#include "res/message.xpm"
#include "res/download.xpm"
#include "res/open.xpm"
#include "res/save.xpm"
#include "res/reload.xpm"
#include "res/edit.xpm"
#include "res/editdelete.xpm"
#include "res/editcopy.xpm"
#include "res/editadd.xpm"
#include "res/translate.xpm"
#include "res/fileclose.xpm"
#include "res/bookmark_add.xpm"
#include "res/info.xpm"
#include "res/filefind.xpm"
#include "res/view_sidetree.xpm"
#include "res/player_play.xpm"
#include "res/player_pause.xpm"

DCMenuHandler::DCMenuHandler()
{
}

DCMenuHandler::~DCMenuHandler()
{
}

/** */
QPopupMenu * DCMenuHandler::_InsertMenu( QPopupMenu * popupmenu, eMenuItems menuitems, bool enabled, QString text )
{
	QPopupMenu * menu = 0;

	if(!popupmenu)
	{
		return menu;
	}

	switch(menuitems)
	{
		case emiSEPARATOR:
				popupmenu->insertSeparator();
				break;
		case emiDOWNLOAD:
				popupmenu->insertItem( QIconSet( QPixmap(download_xpm) ), QObject::tr("Download"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiDOWNLOAD_TO:
				popupmenu->insertItem( QIconSet( QPixmap(download_xpm) ), QObject::tr("Download To"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiDOWNLOAD_AS:
				popupmenu->insertItem( QIconSet( QPixmap(download_xpm) ), QObject::tr("Download As"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiDOWNLOAD_IN:
				popupmenu->insertItem( QObject::tr("Add this extra source"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiBROWSE_USER_FILES:
				popupmenu->insertItem( QIconSet( QPixmap(view_sidetree_xpm) ), QObject::tr("Browse User Files"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiPRIVATE_CHAT:
				popupmenu->insertItem( QIconSet( QPixmap(message_xpm) ), QObject::tr("Private Chat"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiKICK:
				popupmenu->insertItem( QObject::tr("Kick"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiFORCE_MOVE:
				popupmenu->insertItem( QObject::tr("Force Move"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiUPDATE_USER:
				popupmenu->insertItem( QIconSet( QPixmap(reload_xpm) ), QObject::tr("Update User"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiCONNECT:
				popupmenu->insertItem( QIconSet( QPixmap(connect_creating_xpm) ), QObject::tr("Connect"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiDISCONNECT:
				popupmenu->insertItem( QIconSet( QPixmap(connect_no_xpm) ), QObject::tr("Disconnect"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiRELOAD_USERLIST:
				popupmenu->insertItem( QIconSet( QPixmap(reload_xpm) ), QObject::tr("Reload Userlist"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiCONNECT_TO_HUB:
				popupmenu->insertItem( QIconSet( QPixmap(connect_creating_xpm) ), QObject::tr("Connect To Hub"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiCONNECT_TO_ALL_HUBS:
				popupmenu->insertItem( QIconSet( QPixmap(connect_creating_xpm) ), QObject::tr("Connect To All Hubs"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiADD:
				popupmenu->insertItem( QIconSet( QPixmap(editadd_xpm) ), QObject::tr("Add"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiADD_BOOKMARK:
				popupmenu->insertItem( QIconSet( QPixmap(bookmark_add_xpm) ), QObject::tr("Add Bookmark"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiEDIT:
				popupmenu->insertItem( QIconSet( QPixmap(edit_xpm) ), QObject::tr("Edit"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiEDIT_BOOKMARK:
				popupmenu->insertItem( QIconSet( QPixmap(edit_xpm) ), QObject::tr("Edit Bookmark"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiREMOVE:
				popupmenu->insertItem( QIconSet( QPixmap(editdelete_xpm) ), QObject::tr("Remove"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiCLOSE_TRANSFER:
				popupmenu->insertItem( QIconSet( QPixmap(connect_no_xpm) ), QObject::tr("Close Transfer"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiINFO:
				popupmenu->insertItem( QIconSet( QPixmap(info_xpm) ), QObject::tr("Info"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiTRY_CONNECT:
				popupmenu->insertItem( QIconSet( QPixmap(connect_creating_xpm) ), QObject::tr("Try Connect"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiPAUSE_TRANSFER_QUEUE:
				popupmenu->insertItem( QIconSet( QPixmap(player_pause_xpm) ), QObject::tr("Pause Queue"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiRESUME_TRANSFER_QUEUE:
				popupmenu->insertItem( QIconSet( QPixmap(player_play_xpm) ), QObject::tr("Resume Queue"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiREMOVE_TRANSFER_QUEUE:
				popupmenu->insertItem( QIconSet( QPixmap(editdelete_xpm) ), QObject::tr("Remove from Queue"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiREMOVE_TRANSFER_QUEUE_COMPLETE:
				popupmenu->insertItem( QIconSet( QPixmap(editdelete_xpm) ), QObject::tr("Remove complete from Queue"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiREMOVE_TRANSFER_QUEUE_DISK:
				popupmenu->insertItem( QIconSet( QPixmap(editdelete_xpm) ), QObject::tr("Remove Transfer from Queue and Disk"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiADD_USER_SLOT:
				popupmenu->insertItem( QObject::tr("Add Slot to User"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiADD_PERMANENT_USER_SLOT:
				popupmenu->insertItem( QObject::tr("Add Permanent Slot to User"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiREMOVE_USER_SLOT:
				popupmenu->insertItem( QIconSet( QPixmap(editdelete_xpm) ), QObject::tr("Remove Slot from user"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiSAVE_QUEUE:
				popupmenu->insertItem( QIconSet( QPixmap(save_xpm) ), QObject::tr("Save Queue"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiUPDATE_SERVER:
				popupmenu->insertItem( QIconSet( QPixmap(reload_xpm) ), QObject::tr("Update Server"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiUPDATE_ALL_SERVER:
				popupmenu->insertItem( QIconSet( QPixmap(reload_xpm) ), QObject::tr("Update all Server"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiCHANGE_TRANSFER_RATE:
				popupmenu->insertItem( QObject::tr("Change Transfer-Rate"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiCOPY_ROW_TO_CLIPBOARD:
				popupmenu->insertItem( QIconSet( QPixmap(editcopy_xpm) ), QObject::tr("Copy row to Clipboard"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiCOPY_COLUMN_TO_CLIPBOARD:
				popupmenu->insertItem( QIconSet( QPixmap(editcopy_xpm) ), QObject::tr("Copy column to Clipboard"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiFILE_INFO:
				popupmenu->insertItem( QIconSet( QPixmap(info_xpm) ), QObject::tr("File Info"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
				break;
		case emiSEARCH_FILE_CLONE:
				popupmenu->insertItem( QIconSet( QPixmap(filefind_xpm) ), QObject::tr("Search for clones"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiUSER_CAPTION:
				popupmenu->insertItem( text, emiUSER_CAPTION );
				popupmenu->setItemEnabled( emiUSER_CAPTION, enabled );
				break;
		case emiLOAD:
				popupmenu->insertItem( QIconSet( QPixmap(open_xpm) ), QObject::tr("Load"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiSAVE:
				popupmenu->insertItem( QIconSet( QPixmap(save_xpm) ), QObject::tr("Save"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiEDIT_HUB_PROFILES:
				popupmenu->insertItem( QIconSet( QPixmap(edit_xpm) ), QObject::tr("Edit Hub Profiles"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiSET_HUB_PROFILE:
				popupmenu->insertItem( QObject::tr("Set Hub Profile"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiEDIT_TRANSFER:
				popupmenu->insertItem( QIconSet( QPixmap(edit_xpm) ), QObject::tr("Edit transfer"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiEDIT_FILE_PRIORITY:
				popupmenu->insertItem( QIconSet( QPixmap(edit_xpm) ), QObject::tr("Edit file priority"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiTRANSLATE:
				popupmenu->insertItem( QIconSet( QPixmap(translate_xpm) ), QObject::tr("Translate"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiTRANSLATOR:
				popupmenu->insertItem( QObject::tr("Translator"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiINSERTSMILEY:
				popupmenu->insertItem( QObject::tr("Insert Smiley"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiDISABLE_GROUP:
				popupmenu->insertItem( QObject::tr("Disable group"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiGROUP_BY_FILE:
				popupmenu->insertItem( QObject::tr("Group by File"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiGROUP_BY_SIZE:
				popupmenu->insertItem( QObject::tr("Group by Size"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiGROUP_BY_NICK:
				popupmenu->insertItem( QObject::tr("Group by Nick"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiGROUP_BY_SLOTS_FREE:
				popupmenu->insertItem( QObject::tr("Group by free Slots"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiGROUP_BY_HUB:
				popupmenu->insertItem( QObject::tr("Group by Hub"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiGROUP_BY_PATH:
				popupmenu->insertItem( QObject::tr("Group by Path"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiGROUP_BY_HOST:
				popupmenu->insertItem( QObject::tr("Group by Host"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiCOPY:
				popupmenu->insertItem( QIconSet( QPixmap(editcopy_xpm) ), QObject::tr("Copy"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiCLEAR:
				popupmenu->insertItem( QIconSet( QPixmap(editdelete_xpm) ), QObject::tr("Clear"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiSELECT_ALL:
				popupmenu->insertItem( QObject::tr("Select all"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiCLOSE:
				popupmenu->insertItem( QIconSet( QPixmap(fileclose_xpm) ), QObject::tr("Close"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiHIDE:
				popupmenu->insertItem( QObject::tr("Hide"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiREFRESH:
				popupmenu->insertItem( QIconSet( QPixmap(reload_xpm) ), QObject::tr("Refresh Filelist"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		// submenus
		case emisGROUP:
				menu = new QPopupMenu(popupmenu);
				popupmenu->insertItem( QObject::tr("Group"), menu );
				break;
		default:
				break;
	}

	return menu;
}
