/***************************************************************************
                          dcuserslist.h  -  description
                             -------------------
    begin                : Thu Nov 21 2002
    copyright            : (C) 2002 by Franois Gannaz
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DCUSERSLIST_H
#define DCUSERSLIST_H

/**
  *@author Franois Gannaz
  */

#include <DCDialogUsersList.h>

class QWorkspace;

class DCUsersList : public DCDialogUsersList {
Q_OBJECT
public:
	/** */
	DCUsersList(QWidget* parent, const char *name, int wflags);
	/** */
	virtual ~DCUsersList();

	/** */
	void InitDocument();
	/** */
	void DeInitDocument();

	/** */
	void ShowFriendsList();

	/** */
	void AddFriend( QString name, QString host, QString description );
	/** */
	void DelFriend( QString name, QString host, QString description );
	/** */
	void UpdateFriend( QString name, QString host, QString description );

protected:
	/** */
	QWorkspace *pWorkspace;
	/** close event handler */
	virtual void closeEvent(QCloseEvent*) {};

private:
	/** */
	int selectedItems( QListView * list, QPtrList<QListViewItem> & lst );
};

/** */
extern DCUsersList * pUsersList;

#endif
